<template>
	<div class="q-pa-md q-gutter-sm">
		<q-dialog v-model="taskEdit" class="dialog">
			<q-card style="width: 500px;">
				<form>
					<div class="row">
						<q-card-section>
							<div class="text-h6">Update task</div>
						</q-card-section>
						<q-space />
						<q-card-section>
							<q-btn round dense icon="close" v-close-popup />
						</q-card-section>
					</div>

					<q-card-section class="q-pt-none">
						<q-input
							outlined
							v-model="note"
							label="Notes"
							type="textarea"
							:rules="[
								(val) => !!val || 'Field is required',
								(val) =>
									val.length > 2 ||
									'Please use maximum 2 character',
							]"
							ref="note"
						/><q-select
							outlined
							v-model="status"
							:options="options"
							label="Status"
							ref="status"
						/><br />
						<q-btn
							style="width: 100%;"
							label="Update"
							color="primary"
							type="button"
							@click="updateTask"
						/>
					</q-card-section>
				</form>
				<div class="q-pa-md q-gutter-sm">
					<q-dialog
						v-model="alertSuccess"
						persistent
						transition-show="scale"
						transition-hide="scale"
					>
						<q-card
							class="bg-green-9 text-white"
							style="width: 300px;"
						>
							<q-card-section>
								<div class="text-h6">Success</div>
							</q-card-section>

							<q-card-section class="q-pt-none">
								Task has been updated.
							</q-card-section>

							<q-card-actions
								align="right"
								class="bg-white text-teal"
							>
								<q-btn flat label="OK" v-close-popup />
							</q-card-actions>
						</q-card>
					</q-dialog>
				</div>
				<q-card-actions align="right"> </q-card-actions>
			</q-card>
		</q-dialog>
	</div>
</template>
<script>
import { mapGetters } from "vuex";
// import { mapActions } from "vuex";
export default {
	data() {
		return {
			alertSuccess: false,
			options: ["Pending", "On-Going", "Finished"],
		};
	},
	methods: {
		updateTask() {
			this.$refs.note.validate();
			if (!this.$refs.note.hasError) {
				this.$axios.put(this.host + "/src/php/actions/todo.php", {
					todoId: this.todoId,
					note: this.note,
					status: this.status,
				});
				this.alertSuccess = true;
			}
			this.$emit("reload");
		},
	},
	computed: {
		...mapGetters({
			editForm: "showcase/taskEdit",
			todoId: "showcase/todoId",
			todoNote: "showcase/todoNote",
			todoStatus: "showcase/todoStatus",
			// drawerState: "showcase/drawerState",
		}),
		note: {
			get() {
				return this.todoNote;
			},
			set(value) {
				this.$store.commit("showcase/taskNote", value);
			},
		},
		taskEdit: {
			get() {
				return this.editForm;
			},
			set(value) {
				this.$store.commit("showcase/hideEditForm", value);
			},
		},
		status: {
			get() {
				return this.todoStatus;
			},
			set(value) {
				this.$store.commit("showcase/todoStatus", value);
			},
		},

		// todoNote: {
		// 	// getter
		// 	get() {
		// 		return this.todoNote;
		// 	},
		// 	// setter
		// 	set(event) {
		// 		return this.$store.dispatch("taskNote", event.target.todoNote);
		// 	},
		// },
	},
};
</script>
